<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html">http2</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html">HTTP2MimeRequestSourceInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_h_t_t_p2_mime_request_source_interface_8h_source.html">HTTP2MimeRequestSourceInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1acl_1_1_message_request_handler.html" title="alexaClientSDK::acl\l::MessageRequestHandler" alt="" coords="312,5,491,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_mock_h_t_t_p2_mime_request_encode_source.html" title="alexaClientSDK::avsCommon\l::utils::http2::MockHTTP2MimeRequest\lEncodeSource" alt="" coords="275,68,528,120"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a42d24cd62686fabd3defbe7669bbf824"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a42d24cd62686fabd3defbe7669bbf824">~HTTP2MimeRequestSourceInterface</a> ()=default</td></tr>
<tr class="separator:a42d24cd62686fabd3defbe7669bbf824"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ae899f27c30309eb65512401878c0b5"><td class="memItemLeft" align="right" valign="top">virtual std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a3ae899f27c30309eb65512401878c0b5">getRequestHeaderLines</a> ()=0</td></tr>
<tr class="separator:a3ae899f27c30309eb65512401878c0b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7903c99ea0a4a4afa4feee5d9fa4c774"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_get_mime_headers_result.html">HTTP2GetMimeHeadersResult</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a7903c99ea0a4a4afa4feee5d9fa4c774">getMimePartHeaderLines</a> ()=0</td></tr>
<tr class="separator:a7903c99ea0a4a4afa4feee5d9fa4c774"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c3120d58629eda0261063484577c293"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_send_data_result.html">HTTP2SendDataResult</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a5c3120d58629eda0261063484577c293">onSendMimePartData</a> (char *bytes, size_t size)=0</td></tr>
<tr class="separator:a5c3120d58629eda0261063484577c293"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Interface for providing data to be sent as part of a Mime encoded HTTP2 request. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a42d24cd62686fabd3defbe7669bbf824"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a42d24cd62686fabd3defbe7669bbf824">&#9670;&nbsp;</a></span>~HTTP2MimeRequestSourceInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface::~HTTP2MimeRequestSourceInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Default destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a7903c99ea0a4a4afa4feee5d9fa4c774"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7903c99ea0a4a4afa4feee5d9fa4c774">&#9670;&nbsp;</a></span>getMimePartHeaderLines()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_get_mime_headers_result.html">HTTP2GetMimeHeadersResult</a> alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface::getMimePartHeaderLines </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the header lines that should be output with the next mime part. This will be called once before <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a5c3120d58629eda0261063484577c293">onSendMimePartData()</a></code> is called for the first mime part and after each call to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_request_source_interface.html#a5c3120d58629eda0261063484577c293">onSendMimePartData()</a></code> that returns <code><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_send_data_result.html#a11c6b1f4bea60f1435a7e73d810b5a78" title="The status of the send data operation. ">HTTP2SendDataResult.status</a></code> == COMPLETE.</p>
<dl class="section note"><dt>Note</dt><dd>Calls to this method may block network operations for the associated instance of <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_connection_interface.html">HTTP2ConnectionInterface</a>, so they should return quickly.</dd></dl>
<dl class="section return"><dt>Returns</dt><dd>An <code><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_get_mime_headers_result.html">HTTP2GetMimeHeadersResult</a></code> specifying the status of the operation and a vector of header lines if the status was CONTINUE. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_mock_h_t_t_p2_mime_request_encode_source.html#af459bc0d4da20338394093b80b1fc34d">alexaClientSDK::avsCommon::utils::http2::MockHTTP2MimeRequestEncodeSource</a>.</p>

</div>
</div>
<a id="a3ae899f27c30309eb65512401878c0b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ae899f27c30309eb65512401878c0b5">&#9670;&nbsp;</a></span>getRequestHeaderLines()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::vector&lt;std::string&gt; alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface::getRequestHeaderLines </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get the header lines that should be output with this HTTP2 request.</p>
<dl class="section note"><dt>Note</dt><dd>Calls to this method may block network operations for the associated instance of <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_connection_interface.html">HTTP2ConnectionInterface</a>, so they should return quickly.</dd></dl>
<dl class="section return"><dt>Returns</dt><dd>The header lines that should be output with this request. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_mock_h_t_t_p2_mime_request_encode_source.html#a0b575b6ce35202357f576693e1610e67">alexaClientSDK::avsCommon::utils::http2::MockHTTP2MimeRequestEncodeSource</a>.</p>

</div>
</div>
<a id="a5c3120d58629eda0261063484577c293"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5c3120d58629eda0261063484577c293">&#9670;&nbsp;</a></span>onSendMimePartData()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_send_data_result.html">HTTP2SendDataResult</a> alexaClientSDK::avsCommon::utils::http2::HTTP2MimeRequestSourceInterface::onSendMimePartData </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification to copy data to be mime encoded in to an HTTP2 request.</p>
<dl class="section note"><dt>Note</dt><dd>Calls to this method may block network operations for the associated instance of <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_connection_interface.html">HTTP2ConnectionInterface</a>, so they should return quickly.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">bytes</td><td>The buffer to receive the bytes to send. </td></tr>
    <tr><td class="paramname">size</td><td>The max number of bytes to copy. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Result indicating the disposition of the operation and number of bytes copied. </dd></dl>
<dl class="section see"><dt>See also</dt><dd>HTTPSendMimePartDataResult. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_mock_h_t_t_p2_mime_request_encode_source.html#a0a01195692703378fc0963545e116ca4">alexaClientSDK::avsCommon::utils::http2::MockHTTP2MimeRequestEncodeSource</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/HTTP2/<a class="el" href="_h_t_t_p2_mime_request_source_interface_8h_source.html">HTTP2MimeRequestSourceInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
